function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import { render, screen } from '@testing-library/react';
import '@testing-library/jest-dom';
import React from 'react';
import { DropdownContext } from './DropdownContext';
export function testForCustomClass(Component, props = {}) {
  render( /*#__PURE__*/React.createElement(Component, _extends({}, props, {
    "data-testid": "test",
    className: "custom-class"
  })));
  const node = screen.getByTestId('test');
  expect(node).toHaveClass('custom-class');
}
export function testForCustomTag(Component, props = {}, tag = 'h1') {
  render( /*#__PURE__*/React.createElement(Component, _extends({}, props, {
    tag: tag,
    "data-testid": "test"
  })));
  const node = screen.getByTestId('test');
  expect(node.tagName.toLowerCase()).toMatch(tag);
}
export function testForCustomAttribute(Component, props = {}) {
  render( /*#__PURE__*/React.createElement(Component, _extends({}, props, {
    "data-testid": "test",
    "custom-attribute": "custom-value"
  })));
  const node = screen.getByTestId('test');
  expect(node).toHaveAttribute('custom-attribute', 'custom-value');
}
export function testForDefaultTag(Component, tag) {
  render( /*#__PURE__*/React.createElement(Component, {
    "data-testid": "test"
  }));
  const node = screen.getByTestId('test');
  expect(node.tagName.toLowerCase()).toMatch(tag);
}
export function testForDefaultClass(Component, className) {
  render( /*#__PURE__*/React.createElement(Component, {
    "data-testid": "test"
  }));
  const node = screen.getByTestId('test');
  expect(node).toHaveClass(className);
}
export function testForChildrenInComponent(Component) {
  render( /*#__PURE__*/React.createElement(Component, null, "Yo!"));
  expect(screen.getByText('Yo!')).toBeInTheDocument();
}

// Custom render for Dropdown with provider props
export const customDropdownRender = (ui, providerProps) => {
  return render( /*#__PURE__*/React.createElement(DropdownContext.Provider, {
    value: providerProps
  }, ui));
};